Index: blog/external_blog_edit_form.php
=========================================================
--- blog/external_blog_edit_form.php	(revision 0)
+++ blog/external_blog_edit_form.php	Mon Oct 26 17:26:26 WST 2009
@@ -0,0 +1,116 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Moodleform for the user interface for managing external blog links.
+ *
+ * @package    moodlecore
+ * @subpackage blog
+ * @copyright  2009 Nicolas Connault
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require_once($CFG->libdir.'/formslib.php');
+
+class blog_edit_external_form extends moodleform {
+    public function definition() {
+        global $CFG;
+
+        $mform =& $this->_form;
+
+        $mform->addElement('text', 'url', get_string('url'), array('size' => 50));
+        $mform->addRule('url', get_string('emptyurl', 'blog'), 'required', null, 'client');
+        $mform->setHelpButton('url', array('url', get_string('url', 'blog'), 'blog'));
+
+        $mform->addElement('text', 'name', get_string('name'));
+        $mform->setHelpButton('name', array('name', get_string('name', 'blog'), 'blog'));
+
+        $mform->addElement('textarea', 'description', get_string('description'), array('cols' => 50, 'rows' => 7));
+        $mform->setHelpButton('description', array('description', get_string('description', 'blog'), 'blog'));
+
+        if (!empty($CFG->usetags)) {
+            $mform->addElement('text', 'filtertags', get_string('filtertags', 'blog'), array('size' => 50));
+            $mform->setHelpButton('filtertags', array('filtertags', get_string('filtertags', 'blog'), 'blog'));
+            $mform->addElement('text', 'autotags', get_string('autotags', 'blog'), array('size' => 50));
+        }
+
+        $this->add_action_buttons();
+
+        $mform->addElement('hidden', 'id');
+        $mform->setType('id', PARAM_INT);
+        $mform->setDefault('id', 0);
+
+        $mform->addElement('hidden', 'returnurl');
+        $mform->setType('returnurl', PARAM_URL);
+        $mform->setDefault('returnurl', 0);
+    }
+
+    /**
+     * Additional validation includes checking URL and tags
+     */
+    public function validation($data, $files) {
+        global $CFG;
+
+        $errors = parent::validation($data, $files);
+
+        require_once($CFG->libdir . '/simplepie/moodle_simplepie.php');
+
+        $rssfile = new moodle_simplepie_file($data['url']);
+        $filetest = new SimplePie_Locator($rssfile);
+
+        if (!$filetest->is_feed($rssfile)) {
+            $errors['url'] = get_string('feedisinvalid', 'blog');
+        } else {
+            $rss = new moodle_simplepie($data['url']);
+            if (!$rss->init()) {
+                $errors['url'] = get_string('emptyrssfeed', 'blog');
+            }
+        }
+
+        return $errors;
+    }
+
+    public function definition_after_data() {
+        global $CFG, $COURSE;
+        $mform =& $this->_form;
+
+        $name = trim($mform->getElementValue('name'));
+        $description = trim($mform->getElementValue('description'));
+        $url = $mform->getElementValue('url');
+
+        if (empty($name) || empty($description)) {
+            $rss = new moodle_simplepie($url);
+
+            if (empty($name) && $rss->get_title()) {
+                $mform->setDefault('name', $rss->get_title());
+            }
+
+            if (empty($description) && $rss->get_description()) {
+                $mform->setDefault('description', $rss->get_description());
+            }
+        }
+
+        if ($id = $mform->getElementValue('id')) {
+            $mform->setDefault('autotags', implode(',', tag_get_tags_array('blog_external', $id)));
+            $mform->freeze('url');
+            $mform->freeze('filtertags');
+            // TODO change the filtertags element to a multiple select, using the tags of the external blog
+            // Use $rss->get_channel_tags()
+        }
+    }
+}
Index: blog/external_blogs.php
=========================================================
--- blog/external_blogs.php	(revision 0)
+++ blog/external_blogs.php	Fri Oct 23 08:51:34 WST 2009
@@ -0,0 +1,103 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * List of external blogs for current user.
+ *
+ * @package    moodlecore
+ * @subpackage blog
+ * @copyright  2009 Nicolas Connault
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require_once('../config.php');
+require_once('lib.php');
+
+require_login();
+
+$PAGE->set_url('/blog/external_blogs.php');
+require_capability('moodle/blog:manageexternal', get_context_instance(CONTEXT_SYSTEM));
+
+$delete = optional_param('delete', null, PARAM_INT);
+
+$strexternalblogs = get_string('externalblogs','blog');
+$straddnewexternalblog = get_string('addnewexternalblog','blog');
+$strblogs = get_string('blogs','blog');
+$message = null;
+
+if ($delete) {
+    $DB->delete_records('blog_external', array('id' => $delete));
+    $message = get_string('externalblogdeleted', 'blog');
+}
+
+$blogs = $DB->get_records('blog_external', array('userid' => $USER->id));
+
+$PAGE->navbar->add(fullname($USER), new moodle_url($CFG->wwwroot.'/user/view.php', array('id'=>$USER->id)));
+$PAGE->navbar->add($strblogs, new moodle_url($CFG->wwwroot.'/blog/index.php', array('userid'=>$USER->id)));
+$PAGE->navbar->add($strexternalblogs);
+$PAGE->set_heading("$SITE->shortname: $strblogs: $strexternalblogs", $SITE->fullname);
+$PAGE->set_title("$SITE->shortname: $strblogs: $strexternalblogs");
+
+echo $OUTPUT->header();
+echo $OUTPUT->heading($strexternalblogs, 2);
+
+if (!empty($message)) {
+    echo $OUTPUT->notification($message);
+}
+
+echo $OUTPUT->box_start('generalbox boxaligncenter');
+
+if (!empty($blogs)) {
+    $table = new html_table();
+    $table->cellpadding = 4;
+    $table->add_class('generaltable boxaligncenter');
+    $table->head = array(get_string('name'), get_string('url'), get_string('timefetched', 'blog'), get_string('valid', 'blog'), get_string('actions'));
+
+    foreach ($blogs as $blog) {
+        $validicon = html_image::make($OUTPUT->old_icon_url('i/tick_green_big'));
+        $validicon->alt = get_string('feedisvalid', 'blog');
+        $validicon->title = get_string('feedisvalid', 'blog');
+
+        if ($blog->failedlastsync) {
+            $validicon->src = $OUTPUT->old_icon_url('i/cross_red_big');
+            $validicon->alt = get_string('feedisinvalid', 'blog');
+            $validicon->title = get_string('feedisinvalid', 'blog');
+        }
+
+        $editicon = new moodle_action_icon;
+        $editicon->link->url = new moodle_url($CFG->wwwroot.'/blog/external_blog_edit.php', array('id' => $blog->id));
+        $editicon->link->title = get_string('editexternalblog', 'blog');
+        $editicon->image->src = $OUTPUT->old_icon_url('t/edit');
+        $editicon->image->alt = get_string('editexternalblog', 'blog');
+
+        $deleteicon = new moodle_action_icon;
+        $deleteicon->link->url = new moodle_url($CFG->wwwroot.'/blog/external_blogs.php', array('delete' => $blog->id));
+        $deleteicon->link->title = get_string('deleteexternalblog', 'blog');
+        $deleteicon->image->src = $OUTPUT->old_icon_url('t/delete');
+        $deleteicon->image->alt = get_string('deleteexternalblog', 'blog');
+
+        $icons = $OUTPUT->action_icon($editicon) . $OUTPUT->action_icon($deleteicon);
+        $table->data[] = html_table_row::make(array($blog->name, $blog->url, userdate($blog->timefetched), $OUTPUT->image($validicon), $icons));
+    }
+    echo $OUTPUT->table($table);
+}
+
+$newexternalurl = new moodle_url($CFG->wwwroot.'/blog/external_blog_edit.php');
+echo $OUTPUT->link(html_link::make($newexternalurl, $straddnewexternalblog));
+echo $OUTPUT->box_end();
+echo $OUTPUT->footer();
Index: blog/index.php
=========================================================
--- blog/index.php	(revision 1.55)
+++ blog/index.php	Fri Oct 23 10:30:00 WST 2009
@@ -13,16 +13,16 @@
 require_once($CFG->dirroot .'/tag/lib.php');
 require_once($CFG->libdir .'/commentlib.php');
 
-$id           = optional_param('id', null, PARAM_INT);
-$start        = optional_param('formstart', 0, PARAM_INT);
-$tag          = optional_param('tag', '', PARAM_NOTAGS);
-$userid       = optional_param('userid', null, PARAM_INT);
-$tagid        = optional_param('tagid', null, PARAM_INT);
-$modid        = optional_param('modid', null, PARAM_INT);
-$entryid      = optional_param('entryid', null, PARAM_INT);
-$groupid      = optional_param('groupid', null, PARAM_INT);
+$id       = optional_param('id', null, PARAM_INT);
+$start    = optional_param('formstart', 0, PARAM_INT);
+$tag      = optional_param('tag', '', PARAM_NOTAGS);
+$userid   = optional_param('userid', null, PARAM_INT);
+$tagid    = optional_param('tagid', null, PARAM_INT);
+$modid    = optional_param('modid', null, PARAM_INT);
+$entryid  = optional_param('entryid', null, PARAM_INT);
+$groupid  = optional_param('groupid', null, PARAM_INT);
-$courseid     = optional_param('courseid', null, PARAM_INT); // needed for user tabs and course tracking
+$courseid = optional_param('courseid', null, PARAM_INT);
-$search       = optional_param('search', null, PARAM_RAW);
+$search   = optional_param('search', null, PARAM_RAW);
 
 comment::js();
 
@@ -35,8 +35,9 @@
 $PAGE->set_url('blog/index.php', $url_params);
 
 //correct tagid if a text tag is provided as a param
-if (!empty($tag)) {  //text tag parameter takes precedence
-    if ($tagrec = $DB->get_record_sql("SELECT * FROM {tag} WHERE name LIKE ?", array($tag))) {
+if (!empty($tag)) {
+    $ILIKE = $DB->sql_ilike();
+    if ($tagrec = $DB->get_record_sql("SELECT * FROM {tag} WHERE name $ILIKE ?", array("%$tag%"))) {
         $tagid = $tagrec->id;
     } else {
         unset($tagid);
@@ -61,19 +62,16 @@
 
 if (!$userid && has_capability('moodle/blog:view', $sitecontext) && $CFG->bloglevel > BLOG_USER_LEVEL) {
     if ($entryid) {
-        if (!$entryobject = $DB->get_record('blog_entries', array('id'=>$entryid))) {
+        if (!$entryobject = $DB->get_record('post', array('id'=>$entryid))) {
             print_error('nosuchentry', 'blog');
         }
         $userid = $entryobject->userid;
     }
 } else if (!$userid) {
-    // user might have capability to write blogs, but not read blogs at site level
-    // users might enter this url manually without parameters
     $userid = $USER->id;
 }
-/// check access and prepare filters
 
-if (!empty($modid)) {  //check mod access
+if (!empty($modid)) {
     if ($CFG->bloglevel < BLOG_SITE_LEVEL) {
         print_error(get_string('nocourseblogs', 'blog'));
     }
@@ -83,7 +81,7 @@
     $courseid = $mod->course;
 }
 
-if ((empty($courseid) ? true : $courseid == SITEID) && empty($userid)) {  //check site access
+if ((empty($courseid) ? true : $courseid == SITEID) && empty($userid)) {
     if ($CFG->bloglevel < BLOG_SITE_LEVEL) {
         print_error('siteblogdisable', 'blog');
     }
@@ -120,8 +118,7 @@
         print_error('groupblogdisable', 'blog');
     }
 
-        // fix for MDL-9268
-    if (! $group = groups_get_group($groupid)) { //TODO:check.
+    if (! $group = groups_get_group($groupid)) {
         print_error(get_string('invalidgroupid', 'blog'));
     }
 
@@ -182,47 +179,18 @@
 $courseid = (empty($courseid)) ? SITEID : $courseid;
 
 if (!empty($courseid)) {
-    $filters['course'] = $courseid;
     $PAGE->set_context(get_context_instance(CONTEXT_COURSE, $courseid));
 }
 
 if (!empty($modid)) {
-    $filters['module'] = $modid;
     $PAGE->set_context(get_context_instance(CONTEXT_MODULE, $modid));
 }
 
-if (!empty($groupid)) {
-    $filters['group'] = $groupid;
-}
-
-if (!empty($userid)) {
-    $filters['user'] = $userid;
-}
-
-if (!empty($tagid)) {
-    $filters['tag'] = $tagid;
-}
-
-if (!empty($search)) {
-    $filters['search'] = $search;
-}
-
-if (!empty($entryid)) {
-    $filters['entry'] = $entryid;
-}
 $blogheaders = blog_get_headers();
 blog_extend_settings_navigation($PAGE->settingsnav);
 
-// prints the tabs
-$showroles = !empty($userid);
-$currenttab = 'blogs';
-
-$user = $USER;
-$userid = $USER->id;
-
-// Unless this is a user's blog listing, the context is system
 if (empty($entryid) && empty($modid) && empty($groupid)) {
-    $PAGE->set_context(get_context_instance(CONTEXT_USER, $userid));
+    $PAGE->set_context(get_context_instance(CONTEXT_USER, $USER->id));
 }
 
 echo $OUTPUT->header();
@@ -233,8 +201,8 @@
 
 echo $OUTPUT->heading($blogheaders['heading'], 2);
 
-$blog_listing = new blog_listing($filters);
-$blog_listing->print_entries();
+$bloglisting = new blog_listing($blogheaders['filters']);
+$bloglisting->print_entries();
 
 echo $OUTPUT->footer();
 
